;;; **********************************************************************
;;; Copyright (C) 2005 Heinrich Taube, <taube (at) uiuc (dot) edu>
;;;
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the Lisp Lesser Gnu Public License.
;;; See http://www.cliki.net/LLGPL for the text of this agreement.
;;; **********************************************************************

;;; $Name:  $
;;; $Revision: 1.1.1.1 $
;;; $Date: 2005/12/09 15:30:46 $

#-asdf 
(error "Portmidi requires ASDF to load.")

(in-package :cl-user)

;; if CFFI isn't already loaded or on *central-registry*, search for
;; it first under this directory then under the parent directory of
;; this directory, else signal an error.

(unless (or (asdf:find-system :cffi nil)
            (asdf:system-definition-pathname :cffi))
  (flet ((cffi-probe (dir)
           (let ((asd
                  (first (directory
                          (make-pathname :name "cffi" :type "asd"
                                         :directory (append 
                                                     (pathname-directory dir)
                                                     (list :wild))
                                         :defaults dir)))))
             (if asd (push asd asdf:*central-registry*) nil))))
    (let* ((thisdir (make-pathname :type nil :name nil
                                   :defaults (truename *load-pathname*)))
           (rootdir (make-pathname :directory
                                   (butlast (pathname-directory thisdir))
                                   :defaults thisdir)))
      (or (cffi-probe thisdir)
          (cffi-probe rootdir)
          (error "Atempt to load portmidi without CFFI loaded.")))))

(asdf:defsystem :portmidi
  :description "CFFI Interface to Portmidi"
  :author "Rick Taube <taube (at) uiuc (dot) edu>"
  :licence "LLGPL"
  :depends-on (cffi)
  :components ((:file "portmidi")))

